use bevy::{prelude::*, utils::HashMap};

use super::{
    math::{ChunkPos, CHUNK_LENGTH},
    storage::PaletteBloxelStorage,
};

#[derive(Component, Default)]
pub struct Chunk;

#[derive(Component, Deref, DerefMut)]
#[require(Chunk)]
pub struct ChunkData(PaletteBloxelStorage<Entity>);

impl ChunkData {
    pub fn new(default: Entity) -> Self {
        Self(PaletteBloxelStorage::new(
            UVec3::splat(CHUNK_LENGTH as u32),
            default,
        ))
    }
}

#[derive(Component, Default, Deref, DerefMut)]
#[require(Transform, Visibility)]
pub struct ChunkMap(HashMap<ChunkPos, Entity>);
